# xcherryapi
This APIs between xCherry service and SDKs

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 0.0.1
- Package version: 0.0.1
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.7+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/xcherryio/apis.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/xcherryio/apis.git`)

Then import the package:
```python
import xcherryapi
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import xcherryapi
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import time
import xcherryapi
from xcherryapi.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost
# See configuration.py for a list of all supported configuration parameters.
configuration = xcherryapi.Configuration(
    host = "http://localhost"
)



# Enter a context with an instance of the API client
with xcherryapi.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = xcherryapi.DefaultApi(api_client)
    process_execution_describe_request = xcherryapi.ProcessExecutionDescribeRequest() # ProcessExecutionDescribeRequest |  (optional)

    try:
        # describe a process execution
        api_response = api_instance.api_v1_xcherry_service_process_execution_describe_post(process_execution_describe_request=process_execution_describe_request)
        print("The response of DefaultApi->api_v1_xcherry_service_process_execution_describe_post:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling DefaultApi->api_v1_xcherry_service_process_execution_describe_post: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DefaultApi* | [**api_v1_xcherry_service_process_execution_describe_post**](docs/DefaultApi.md#api_v1_xcherry_service_process_execution_describe_post) | **POST** /api/v1/xcherry/service/process-execution/describe | describe a process execution
*DefaultApi* | [**api_v1_xcherry_service_process_execution_publish_to_local_queue_post**](docs/DefaultApi.md#api_v1_xcherry_service_process_execution_publish_to_local_queue_post) | **POST** /api/v1/xcherry/service/process-execution/publish-to-local-queue | send message(s) to be consumed within a single process execution
*DefaultApi* | [**api_v1_xcherry_service_process_execution_rpc_post**](docs/DefaultApi.md#api_v1_xcherry_service_process_execution_rpc_post) | **POST** /api/v1/xcherry/service/process-execution/rpc | execute a RPC method of a process execution
*DefaultApi* | [**api_v1_xcherry_service_process_execution_start_post**](docs/DefaultApi.md#api_v1_xcherry_service_process_execution_start_post) | **POST** /api/v1/xcherry/service/process-execution/start | start a process execution
*DefaultApi* | [**api_v1_xcherry_service_process_execution_stop_post**](docs/DefaultApi.md#api_v1_xcherry_service_process_execution_stop_post) | **POST** /api/v1/xcherry/service/process-execution/stop | stop a process execution
*DefaultApi* | [**api_v1_xcherry_worker_async_state_execute_post**](docs/DefaultApi.md#api_v1_xcherry_worker_async_state_execute_post) | **POST** /api/v1/xcherry/worker/async-state/execute | invoking AsyncState.execute API
*DefaultApi* | [**api_v1_xcherry_worker_async_state_wait_until_post**](docs/DefaultApi.md#api_v1_xcherry_worker_async_state_wait_until_post) | **POST** /api/v1/xcherry/worker/async-state/wait-until | invoking AsyncState.waitUntil API
*DefaultApi* | [**api_v1_xcherry_worker_process_rpc_post**](docs/DefaultApi.md#api_v1_xcherry_worker_process_rpc_post) | **POST** /api/v1/xcherry/worker/process/rpc | execute a RPC method of a process execution in the worker
*DefaultApi* | [**internal_api_v1_xcherry_notify_immediate_tasks_post**](docs/DefaultApi.md#internal_api_v1_xcherry_notify_immediate_tasks_post) | **POST** /internal/api/v1/xcherry/notify-immediate-tasks | for api service to tell async service that there are new immediate tasks added to the queue
*DefaultApi* | [**internal_api_v1_xcherry_notify_timer_tasks_post**](docs/DefaultApi.md#internal_api_v1_xcherry_notify_timer_tasks_post) | **POST** /internal/api/v1/xcherry/notify-timer-tasks | for api service to tell async service that there are new timer tasks added to the queue


## Documentation For Models

 - [ApiErrorResponse](docs/ApiErrorResponse.md)
 - [AppDatabaseColumnValue](docs/AppDatabaseColumnValue.md)
 - [AppDatabaseConfig](docs/AppDatabaseConfig.md)
 - [AppDatabaseError](docs/AppDatabaseError.md)
 - [AppDatabaseErrorHandling](docs/AppDatabaseErrorHandling.md)
 - [AppDatabaseReadRequest](docs/AppDatabaseReadRequest.md)
 - [AppDatabaseReadResponse](docs/AppDatabaseReadResponse.md)
 - [AppDatabaseRowReadResponse](docs/AppDatabaseRowReadResponse.md)
 - [AppDatabaseRowWrite](docs/AppDatabaseRowWrite.md)
 - [AppDatabaseTableConfig](docs/AppDatabaseTableConfig.md)
 - [AppDatabaseTableReadRequest](docs/AppDatabaseTableReadRequest.md)
 - [AppDatabaseTableReadResponse](docs/AppDatabaseTableReadResponse.md)
 - [AppDatabaseTableRowSelector](docs/AppDatabaseTableRowSelector.md)
 - [AppDatabaseTableWrite](docs/AppDatabaseTableWrite.md)
 - [AppDatabaseWrite](docs/AppDatabaseWrite.md)
 - [AsyncStateConfig](docs/AsyncStateConfig.md)
 - [AsyncStateExecuteRequest](docs/AsyncStateExecuteRequest.md)
 - [AsyncStateExecuteResponse](docs/AsyncStateExecuteResponse.md)
 - [AsyncStateWaitUntilRequest](docs/AsyncStateWaitUntilRequest.md)
 - [AsyncStateWaitUntilResponse](docs/AsyncStateWaitUntilResponse.md)
 - [CommandRequest](docs/CommandRequest.md)
 - [CommandResults](docs/CommandResults.md)
 - [CommandStatus](docs/CommandStatus.md)
 - [CommandWaitingType](docs/CommandWaitingType.md)
 - [Context](docs/Context.md)
 - [DatabaseLockingType](docs/DatabaseLockingType.md)
 - [EncodedObject](docs/EncodedObject.md)
 - [ErrorSubType](docs/ErrorSubType.md)
 - [KeyValue](docs/KeyValue.md)
 - [LoadLocalAttributesRequest](docs/LoadLocalAttributesRequest.md)
 - [LoadLocalAttributesResponse](docs/LoadLocalAttributesResponse.md)
 - [LocalAttributeConfig](docs/LocalAttributeConfig.md)
 - [LocalQueueCommand](docs/LocalQueueCommand.md)
 - [LocalQueueMessage](docs/LocalQueueMessage.md)
 - [LocalQueueMessageResult](docs/LocalQueueMessageResult.md)
 - [LocalQueueResult](docs/LocalQueueResult.md)
 - [NotifyImmediateTasksRequest](docs/NotifyImmediateTasksRequest.md)
 - [NotifyTimerTasksRequest](docs/NotifyTimerTasksRequest.md)
 - [ProcessExecutionDescribeRequest](docs/ProcessExecutionDescribeRequest.md)
 - [ProcessExecutionDescribeResponse](docs/ProcessExecutionDescribeResponse.md)
 - [ProcessExecutionRpcRequest](docs/ProcessExecutionRpcRequest.md)
 - [ProcessExecutionRpcResponse](docs/ProcessExecutionRpcResponse.md)
 - [ProcessExecutionStartRequest](docs/ProcessExecutionStartRequest.md)
 - [ProcessExecutionStartResponse](docs/ProcessExecutionStartResponse.md)
 - [ProcessExecutionStopRequest](docs/ProcessExecutionStopRequest.md)
 - [ProcessExecutionStopType](docs/ProcessExecutionStopType.md)
 - [ProcessIdReusePolicy](docs/ProcessIdReusePolicy.md)
 - [ProcessRpcWorkerRequest](docs/ProcessRpcWorkerRequest.md)
 - [ProcessRpcWorkerResponse](docs/ProcessRpcWorkerResponse.md)
 - [ProcessStartConfig](docs/ProcessStartConfig.md)
 - [ProcessStatus](docs/ProcessStatus.md)
 - [PublishToLocalQueueRequest](docs/PublishToLocalQueueRequest.md)
 - [RetryPolicy](docs/RetryPolicy.md)
 - [StateDecision](docs/StateDecision.md)
 - [StateFailureRecoveryOptions](docs/StateFailureRecoveryOptions.md)
 - [StateFailureRecoveryPolicy](docs/StateFailureRecoveryPolicy.md)
 - [StateMovement](docs/StateMovement.md)
 - [ThreadCloseDecision](docs/ThreadCloseDecision.md)
 - [ThreadCloseType](docs/ThreadCloseType.md)
 - [TimerCommand](docs/TimerCommand.md)
 - [TimerResult](docs/TimerResult.md)
 - [WorkerApiType](docs/WorkerApiType.md)
 - [WorkerErrorResponse](docs/WorkerErrorResponse.md)
 - [WriteConflictMode](docs/WriteConflictMode.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization

Endpoints do not require authorization.


## Author




