# coding: utf-8

"""
    xCherry APIs

    This APIs between xCherry service and SDKs

    The version of the OpenAPI document: 0.0.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictInt, StrictStr
from pydantic import Field
from xcherryapi.models.worker_api_type import WorkerApiType
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class Context(BaseModel):
    """
    Context
    """ # noqa: E501
    process_id: StrictStr = Field(alias="processId")
    process_execution_id: StrictStr = Field(alias="processExecutionId")
    process_started_timestamp: StrictInt = Field(alias="processStartedTimestamp")
    state_execution_id: Optional[StrictStr] = Field(default=None, description="stateExecutionId is for async state API only", alias="stateExecutionId")
    first_attempt_timestamp: Optional[StrictInt] = Field(default=None, description="for async state API only(during backoff retry)", alias="firstAttemptTimestamp")
    attempt: Optional[StrictInt] = Field(default=None, description="for async state API only(during backoff retry)")
    recover_from_state_execution_id: Optional[StrictStr] = Field(default=None, description="for async state API only, state id + sequence number", alias="recoverFromStateExecutionId")
    recover_from_api: Optional[WorkerApiType] = Field(default=None, alias="recoverFromApi")
    __properties: ClassVar[List[str]] = ["processId", "processExecutionId", "processStartedTimestamp", "stateExecutionId", "firstAttemptTimestamp", "attempt", "recoverFromStateExecutionId", "recoverFromApi"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of Context from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of Context from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "processId": obj.get("processId"),
            "processExecutionId": obj.get("processExecutionId"),
            "processStartedTimestamp": obj.get("processStartedTimestamp"),
            "stateExecutionId": obj.get("stateExecutionId"),
            "firstAttemptTimestamp": obj.get("firstAttemptTimestamp"),
            "attempt": obj.get("attempt"),
            "recoverFromStateExecutionId": obj.get("recoverFromStateExecutionId"),
            "recoverFromApi": obj.get("recoverFromApi")
        })
        return _obj


