# coding: utf-8

"""
    xCherry APIs

    This APIs between xCherry service and SDKs

    The version of the OpenAPI document: 0.0.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional, Union
from pydantic import BaseModel, StrictFloat, StrictInt
from pydantic import Field
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class RetryPolicy(BaseModel):
    """
    RetryPolicy
    """ # noqa: E501
    initial_interval_seconds: Optional[StrictInt] = Field(default=None, description="the initial interval for the first retry, default to 1 second", alias="initialIntervalSeconds")
    backoff_coefficient: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="the backoff coefficient for the next retry, default to 2", alias="backoffCoefficient")
    maximum_interval_seconds: Optional[StrictInt] = Field(default=None, description="the maximum interval for the next retry, default to 100x of initial interval", alias="maximumIntervalSeconds")
    maximum_attempts: Optional[StrictInt] = Field(default=None, description="the maximum number of attempts, default to 0, means unlimited", alias="maximumAttempts")
    maximum_attempts_duration_seconds: Optional[StrictInt] = Field(default=None, description="the maximum duration of all attempts, default to 0, means unlimited", alias="maximumAttemptsDurationSeconds")
    __properties: ClassVar[List[str]] = ["initialIntervalSeconds", "backoffCoefficient", "maximumIntervalSeconds", "maximumAttempts", "maximumAttemptsDurationSeconds"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of RetryPolicy from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of RetryPolicy from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "initialIntervalSeconds": obj.get("initialIntervalSeconds"),
            "backoffCoefficient": obj.get("backoffCoefficient"),
            "maximumIntervalSeconds": obj.get("maximumIntervalSeconds"),
            "maximumAttempts": obj.get("maximumAttempts"),
            "maximumAttemptsDurationSeconds": obj.get("maximumAttemptsDurationSeconds")
        })
        return _obj


