# coding: utf-8

"""
    xCherry APIs

    This APIs between xCherry service and SDKs

    The version of the OpenAPI document: 0.0.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel
from pydantic import Field
from xcherryapi.models.state_movement import StateMovement
from xcherryapi.models.thread_close_decision import ThreadCloseDecision
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class StateDecision(BaseModel):
    """
    the decision at the end of state execution, either nextStates or threadCloseDecision is needed
    """ # noqa: E501
    next_states: Optional[List[StateMovement]] = Field(default=None, alias="nextStates")
    thread_close_decision: Optional[ThreadCloseDecision] = Field(default=None, alias="threadCloseDecision")
    __properties: ClassVar[List[str]] = ["nextStates", "threadCloseDecision"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of StateDecision from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in next_states (list)
        _items = []
        if self.next_states:
            for _item in self.next_states:
                if _item:
                    _items.append(_item.to_dict())
            _dict['nextStates'] = _items
        # override the default output from pydantic by calling `to_dict()` of thread_close_decision
        if self.thread_close_decision:
            _dict['threadCloseDecision'] = self.thread_close_decision.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of StateDecision from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "nextStates": [StateMovement.from_dict(_item) for _item in obj.get("nextStates")] if obj.get("nextStates") is not None else None,
            "threadCloseDecision": ThreadCloseDecision.from_dict(obj.get("threadCloseDecision")) if obj.get("threadCloseDecision") is not None else None
        })
        return _obj


